//============================================================================
//
//This confidential	and	proprietary	software may be	used only as authorized
//by a licensing agreement from	Texas Instruments, US.
//
//	   In the event	of publication,	the	following notice is	applicable:
//
//						  (C) COPYRIGHT	2009 TI
//							ALL	RIGHTS RESERVED
//
// Entire notice above must	be reproduced on all authorized	copies.
//
//
// Title:	   %M%
// Version:	   %I%
// Date:	   %G%
// Author:	   Hamza Fraz
//
// Design taken from
// http://www.sunburst-design.com/papers/CummingsSNUG2003Boston_Resets.pdf
//============================================================================


module tsw1405_reset(
output	reg		rst_n,
input			clk,
input			reset_n,
input			sw_reset
);

//-----------------------------------------------------------------------------

reg				rff1;

//-----------------------------------------------------------------------------

always @(posedge clk or negedge reset_n)
begin
	if (!reset_n)
		{rst_n,rff1} <= 2'b0;
	else if (sw_reset)
		{rst_n,rff1} <= 2'b0;	
	else
		{rst_n,rff1} <= {rff1,1'b1};
end

//-----------------------------------------------------------------------------

endmodule